#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Pdf;
using Syncfusion.Pdf.DLS;
using Syncfusion.DLS;
using Syncfusion.Pdf.Shared;
using System.IO;

namespace EssentialPDFSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Bitmap)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(464, 72);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "PDF";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(544, 56);
			this.label1.TabIndex = 1;
			this.label1.Text = @"Clicking the button below will result in a new PDF document being generated using Essential PDF.  At the end of the document generation, an option will be provided to view the generated PDF file. Please note that you need to have a PDF viewer installed in order to view the generated PDF file.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 102);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential PDF Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Cursor = Cursors.WaitCursor;

			//Create a new PDF Document. This object represents the PDF document.
			//This document has One page by default. Additional pages have to be added.
			PDFDocument pdfDoc = new PDFDocument();

			//Access the first page in the PDFDocuments's pages collection
			IPDFPage currentPage = pdfDoc.Pages[0];

			//Use the Predefined fonts to draw the text. 
			IPDFFont pdfFont = pdfDoc.Fonts.Add(new Font(FontFamily.Families[1], 36, FontStyle.Bold), true);
			IPDFGraphicState props = pdfDoc.CreateGraphicState();
			props.TextAlignment = TextAlignment.Center;
			string title = "Study 1";
			currentPage.Graphics.DrawMultiText(200, currentPage.Size.Height / 2 - 100, currentPage.Size.Width, title, pdfFont, props);

			//string directoryPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + @"\My Studies\PDF Export Images";
			string directoryPath = "../../Data";
			DirectoryInfo dirInfo = new DirectoryInfo(directoryPath);

			foreach (FileInfo file in dirInfo.GetFiles("*.emf"))
			{
				// add a new page for each exhibit
				currentPage = pdfDoc.Pages.CreatePage(new PDFPadding(0));

				//Draw the image at the specified coordinates.
				IPDFImage pdfImage = pdfDoc.Graphics.CreatePdfImage(Image.FromFile(file.FullName));
				currentPage.Size = new SizeF(pdfImage.Width, pdfImage.Height);
				currentPage.Graphics.DrawImage(new Point(150, 0), pdfImage);

				pdfDoc.Pages.Add(currentPage);
			}

			currentPage = pdfDoc.Pages.CreatePage(new PDFPadding(0));
			currentPage.Orientation = Syncfusion.Pdf.PageOrientation.Portrait;
			title = "End of Study";
			currentPage.Graphics.DrawMultiText(250, currentPage.Size.Height / 2 - 100, currentPage.Size.Width, title, pdfFont, props);
			pdfDoc.Pages.Add(currentPage);

			//string filePath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + @"\Sample.pdf";
			string filePath = "Sample.pdf";

			//Save the PDF Document to disk.
			pdfDoc.Save(filePath);

			//Open the PDF document that was created using Essential PDF.
			System.Diagnostics.Process.Start(filePath);

			Cursor = Cursors.Default;
		}
	}
}
